OGRE: Resources

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Resources
Core

## Classes
class | Ogre::APKFileSystemArchiveFactory
class | Ogre::Archive
| Archive-handling class. More...
class | Ogre::ArchiveFactory
| Abstract factory class, archive codec plugins can register concrete subclasses of this. More...
class | Ogre::ArchiveManager
| This class manages the available ArchiveFactory plugins. More...
class | Ogre::DataStream
| General purpose class used for encapsulating the reading and writing of data. More...
class | Ogre::DefaultTextureManager
| Specialisation of TextureManager for offline processing. Cannot be used with an active RenderSystem. More...
class | Ogre::EmbeddedZipArchiveFactory
| Specialisation of ZipArchiveFactory for embedded Zip files. More...
class | Ogre::FileHandleDataStream
| Common subclass of DataStream for handling data from C-style file handles. More...
struct | Ogre::FileInfo
| Information about a file/directory within the archive will be returned using a FileInfo struct. More...
class | Ogre::FileStreamDataStream
| Common subclass of DataStream for handling data from std::basic_istream. More...
class | Ogre::FileSystemArchiveFactory
| Specialisation of the ArchiveFactory to allow reading of files from filesystem folders / directories. More...
class | Ogre::GpuProgram
| Defines a program which runs on the GPU such as a vertex or fragment program. More...
class | Ogre::GpuProgramFactory
| Interface definition for factories of GpuProgram. More...
class | Ogre::GpuProgramManager
| This ResourceManager manages GPU shader programs. More...
class | Ogre::HighLevelGpuProgram
| Abstract base class representing a high-level program (a vertex or fragment program). More...
class | Ogre::ManualResourceLoader
| Interface describing a manual resource loader. More...
class | Ogre::MemoryDataStream
| Common subclass of DataStream for handling data from chunks of memory. More...
class | Ogre::Mesh
| Resource holding data about 3D mesh. More...
struct | Ogre::MeshLodUsage
| A way of recording the way each LODs is recorded this Mesh. More...
class | Ogre::MeshManager
| Handles the management of mesh resources. More...
class | Ogre::MeshSerializer
| Class for serialising mesh data to/from an OGRE .mesh file. More...
class | Ogre::MeshSerializerListener
| This class allows users to hook into the mesh loading process and modify references within the mesh as they are loading. More...
class | Ogre::Resource
| Abstract class representing a loadable resource. More...
class | Ogre::ResourceBackgroundQueue
| This class is used to perform Resource operations in a background thread. More...
class | Ogre::ResourceGroupListener
| This class defines an interface which is called back during resource group loading to indicate the progress of the load. More...
class | Ogre::ResourceGroupManager
| This singleton class manages the list of resource groups, and notifying the various resource managers of their obligations to load / unload resources in a group. More...
class | Ogre::ResourceLoadingListener
| This class allows users to override resource loading behavior. More...
class | Ogre::ResourceManager
| Defines a generic resource handler. More...
class | Ogre::StreamSerialiser
| Utility class providing helper methods for reading / writing structured data held in a DataStream. More...
class | Ogre::SubMesh
| Defines a part of a complete mesh. More...
class | Ogre::Texture
| Abstract class representing a Texture resource. More...
class | Ogre::TextureManager
| Class for loading & managing textures. More...
class | Ogre::ZipArchiveFactory
| Specialisation to allow reading of files from a zip format source archive. More...

## Typedefs
typedef std::list< DataStreamPtr > | Ogre::DataStreamList
| List of DataStream items.
typedef std::vector< FileInfo > | Ogre::FileInfoList
typedef SharedPtr< FileInfoList > | Ogre::FileInfoListPtr

## Enumerations
enum | { Ogre::GPT_COUNT = GPT_TASK_PROGRAM + 1 , Ogre::GPT_PIPELINE_COUNT = GPT_HULL_PROGRAM + 1 }
enum | Ogre::GpuProgramType : uint8 { Ogre::GPT_VERTEX_PROGRAM = 0 , Ogre::GPT_FRAGMENT_PROGRAM , Ogre::GPT_GEOMETRY_PROGRAM , Ogre::GPT_DOMAIN_PROGRAM , Ogre::GPT_HULL_PROGRAM , Ogre::GPT_MESH_PROGRAM , Ogre::GPT_COMPUTE_PROGRAM , Ogre::GPT_TASK_PROGRAM }
| Enumerates the types of programs which can run on the GPU. More...
enum | Ogre::TextureAccess { Ogre::TA_READ = 0x01 , Ogre::TA_WRITE = 0x10 , Ogre::TA_READ_WRITE = TA_READ | TA_WRITE }
| Enum identifying the texture access privilege. More...
enum | Ogre::TextureMipmap { Ogre::MIP_UNLIMITED = 0x7FFFFFFF , Ogre::MIP_DEFAULT = -1 }
| Enum identifying special mipmap numbers. More...
enum | Ogre::TextureType : uint8 { Ogre::TEX_TYPE_1D = 1 , Ogre::TEX_TYPE_2D = 2 , Ogre::TEX_TYPE_3D = 3 , Ogre::TEX_TYPE_CUBE_MAP = 4 , Ogre::TEX_TYPE_2D_ARRAY = 5 , Ogre::TEX_TYPE_2D_MULTISAMPLE = 6 , Ogre::TEX_TYPE_EXTERNAL_OES = 7 }
| Enum identifying the texture type. More...
enum | Ogre::TextureUsage { Ogre::TU_STATIC = HBU_GPU_TO_CPU , Ogre::TU_DYNAMIC = HBU_CPU_ONLY , Ogre::TU_WRITE_ONLY = HBU_DETAIL_WRITE_ONLY , Ogre::TU_STATIC_WRITE_ONLY = HBU_GPU_ONLY , Ogre::TU_DYNAMIC_WRITE_ONLY = HBU_CPU_TO_GPU , Ogre::TU_DYNAMIC_WRITE_ONLY_DISCARDABLE = HBU_CPU_TO_GPU , Ogre::TU_AUTOMIPMAP = 0x10 , Ogre::TU_RENDERTARGET = 0x20 , Ogre::TU_NOT_SAMPLED = 0x40 , Ogre::TU_UNORDERED_ACCESS = 0x80 , Ogre::TU_TARGET_ALL_LAYERS = 0x100 , Ogre::TU_DEFAULT = TU_AUTOMIPMAP | HBU_GPU_ONLY , Ogre::TU_UAV_NOT_SRV = TU_UNORDERED_ACCESS | TU_NOT_SAMPLED , Ogre::TU_NOT_SRV = TU_NOT_SAMPLED , Ogre::TU_NOTSHADERRESOURCE = TU_NOT_SAMPLED , Ogre::TU_UAV = TU_UNORDERED_ACCESS }
| Enum identifying the texture usage. More...

## Functions
DataStreamPtr | Ogre::_openFileStream (const String &path, std::ios::openmode mode, const String &name="")
| internal method to open a FileStreamDataStream
String | Ogre::to_string (const GpuProgramType &v)

## Variables
_OgreExport const char *const | Ogre::RGN_AUTODETECT
| Special resource group name which causes resource group to be automatically determined based on searching for the resource in all groups.
_OgreExport const char *const | Ogre::RGN_DEFAULT
| Default resource group name.
_OgreExport const char *const | Ogre::RGN_INTERNAL
| Internal resource group name (should be used by OGRE internal only).

## Detailed Description

## Typedef Documentation

## ◆ FileInfoList

typedef std::vector<FileInfo> Ogre::FileInfoList

## ◆ FileInfoListPtr

typedef SharedPtr<FileInfoList> Ogre::FileInfoListPtr

## ◆ DataStreamList

typedef std::list<DataStreamPtr> Ogre::DataStreamList

List of DataStream items.

## Enumeration Type Documentation

## ◆ GpuProgramType

enum Ogre::GpuProgramType : uint8

Enumerates the types of programs which can run on the GPU.

Enumerator
GPT_VERTEX_PROGRAM |
GPT_FRAGMENT_PROGRAM |
GPT_GEOMETRY_PROGRAM |
GPT_DOMAIN_PROGRAM |
GPT_HULL_PROGRAM |
GPT_MESH_PROGRAM |
GPT_COMPUTE_PROGRAM |
GPT_TASK_PROGRAM |

## ◆ anonymous enum

anonymous enum

Enumerator
GPT_COUNT |
GPT_PIPELINE_COUNT | max programs that can be active in a pipeline (e.g compute is separate)

## ◆ TextureUsage

enum Ogre::TextureUsage

Enum identifying the texture usage.

Enumerator
TU_STATIC | same as HBU_GPU_TO_CPU
TU_DYNAMIC | same as HBU_CPU_ONLY
TU_WRITE_ONLY | same as HBU_DETAIL_WRITE_ONLY
TU_STATIC_WRITE_ONLY | same as HBU_GPU_ONLY
TU_DYNAMIC_WRITE_ONLY | same as HBU_CPU_TO_GPU
TU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Deprecated do not use
TU_AUTOMIPMAP | Mipmaps will be automatically generated for this texture.
TU_RENDERTARGET | This texture will be a render target, i.e. used as a target for render to texture setting this flag will ignore all other texture usages except TU_AUTOMIPMAP, TU_UNORDERED_ACCESS, TU_NOT_SAMPLED
TU_NOT_SAMPLED | Texture will not be sampled inside a shader i.e. used as regular texture. When used with TU_RENDERTARGET this can improve performance and compatibility with FL9.1 hardware
TU_UNORDERED_ACCESS | Texture can be bound as an Unordered Access View (imageStore/imageRead/glBindImageTexture in GL jargon).
TU_TARGET_ALL_LAYERS | Create only a single render target which will be used for all layers only relevant for layered textures like 2D arrays and cube maps.
TU_DEFAULT | Default to automatic mipmap generation static textures.
TU_UAV_NOT_SRV | Deprecated
TU_NOT_SRV | Deprecated
TU_NOTSHADERRESOURCE | Deprecated
TU_UAV | Deprecated

## ◆ TextureAccess

enum Ogre::TextureAccess

Enum identifying the texture access privilege.

Enumerator
TA_READ |
TA_WRITE |
TA_READ_WRITE |

## ◆ TextureType

enum Ogre::TextureType : uint8

Enum identifying the texture type.

Enumerator
TEX_TYPE_1D | 1D texture, used in combination with 1D texture coordinates
TEX_TYPE_2D | 2D texture, used in combination with 2D texture coordinates (default)
TEX_TYPE_3D | 3D volume texture, used in combination with 3D texture coordinates
TEX_TYPE_CUBE_MAP | cube map (six two dimensional textures, one for each cube face), used in combination with 3D texture coordinates
TEX_TYPE_2D_ARRAY | 2D texture array
TEX_TYPE_2D_MULTISAMPLE | 2D texture with multiple samples per pixel, allows manual MSAA resolve
TEX_TYPE_EXTERNAL_OES | GLES2 only OES texture type.

## ◆ TextureMipmap

enum Ogre::TextureMipmap

Enum identifying special mipmap numbers.

Enumerator
MIP_UNLIMITED | Generate mipmaps up to 1x1.
MIP_DEFAULT | Use TextureManager default.

## Function Documentation

## ◆ _openFileStream()

DataStreamPtr Ogre::_openFileStream | ( | const String & | path,
|  | std::ios::openmode | mode,
|  | const String & | name = "" )

internal method to open a FileStreamDataStream

## ◆ to_string()

String Ogre::to_string | ( | const GpuProgramType & | v | ) |
| inline

References Ogre::GpuProgram::getProgramTypeName().

## Variable Documentation

## ◆ RGN_DEFAULT

_OgreExport const char* const Ogre::RGN_DEFAULT
| extern

Default resource group name.

## ◆ RGN_INTERNAL

_OgreExport const char* const Ogre::RGN_INTERNAL
| extern

Internal resource group name (should be used by OGRE internal only).

## ◆ RGN_AUTODETECT

_OgreExport const char* const Ogre::RGN_AUTODETECT
| extern

Special resource group name which causes resource group to be automatically determined based on searching for the resource in all groups.